<?php
/**
 * @package		
 * @copyright		Copyright (C) 2012 CNPINTEGRATIONS.COM. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.event.plugin' );
jimport( 'joomla.language.helper');


/**
* Access Plugin
*
* <b>Usage:</b>
* <code>{accesscontrol [!]group[,group]}...some content...{/accesscontrol}</code>
*
* One ore more group name should be passed, you can expressly deny access by putting a '!'
* before the group name in question.  It will keep looping through the list provided until
* it finds a 'true' value so strange results may occur with conflicting group access. 
*
* Examples:
*
*		{accesscontrol Guest}shows only to Guest groups members{/accesscontrol}
*		{accesscontrol !Guest}shows to all users who are not a member of the Guest group{/accesscontrol}
*		{accesscontrol Registered}shows to all Registered{/accesscontrol}
*		{accesscontrol Member}shows to all members of the Members Group{/accesscontrol}
*
*/

/**
* Process the plugin
*/
// ************************************************************************/
jimport('joomla.plugin.plugin');
if (version_compare(JVERSION, '1.6.0', 'ge')){
	jimport('joomla.html.parameter');
}


class PlgContentAccessControlTags extends JPlugin
{

   function __construct ($row, $params='', $page=0 ) {
      parent::__construct($row, $params='', $page=0  );

      $this->_plugin = JPluginHelper::getPlugin( 'content', 'PlgAccessControlTags' );
      $this->_params = new JRegistry( $this->_plugin->params );

//your additional code
   }
public function onContentPrepare($context, $row, $params, $page = 0){
	//Access the database

	$db = JFactory::getDBO();
	//Check whether the bot should process or not
	if ( JString::strpos( $row->text, 'accesscontrol' ) === false ) {
		return true;
	}

	//Get plugin info
	 
	//Search for this tag in the content
	$regex = "#{accesscontrol(.*?)}(.*?){/accesscontrol}#s";
	 
	preg_match_all( $regex, $row->text, $matches );

	$count = count( $matches[0] );
	//Plugin only processes if there are any instances of the plugin in the text
	if ( $count ) {
		$this->plgAccessControlProcessPositions( $row, $matches, $count, $regex );
	}

}
// ************************************************************************/

/**
* Process the positions
*/
// ************************************************************************/
function plgAccessControlProcessPositions ( $row, $matches, $count, $regex, $style='' ) {
$text="";
 	for ( $i=0; $i < $count; $i++ ) {   
		//Load position
		unset($thisposition);
		$thisposition[0] = $matches[0][$i];
		$thisposition[1] = $matches[1][$i];
		$thisposition[2] = $matches[2][$i];		
		$replace	= $this->plgAccessControl_replacer( $thisposition );
		if ($replace) { 
			$row->text = preg_replace( '{'. $matches[0][$i] .'}', $replace, $row->text ); 
		} else { 
			$row->text = preg_replace( '{'. $matches[0][$i] .'}', '', $row->text ); 
		}
	}
	 
}
// ************************************************************************/

/**
* Replaces the matched positions
*/
// ************************************************************************/
	function plgAccessControl_replacer( $matches ) {
		$database = JFactory::getDBO();
		$my 	= JFactory::getUser();

		$return = "";
		$negated = "";

		$text = $matches[2];
		if (@$matches[1]) {
			$accessLevels = explode(",", trim($matches[1]));
			foreach ($accessLevels as $access) {
				$negoffset = strpos($access, '!');
				if ($negoffset === false) {
					// if no "!" found, simply check if the user is a member of this group
					if ($this->hasAccessLevel(trim($access), $negoffset)) { 
						$return = $text; 
					}	
				} else {
					// if "!" found, check if the user is a member of this group, and if not, return empty string
					$access = substr($access, $negoffset+1);
					if ($this->hasAccessLevel(trim($access), false)) { 
						$negated = true; 
					}
				}
			}

		}
	
		if (!$negated) { 
			return $return; 
		} else { 
			return ''; 
		}
	}
// ************************************************************************/

/**
* Replaces the matched positions
*/
// ************************************************************************/
	function hasAccessLevel($level, $operator=true) {
		$database = JFactory::getDBO();
		$my 	= JFactory::getUser();
		jimport( 'joomla.user.helper' );
		$groups = JUserHelper::getUserGroups($my->id);

		$group_match = false;
		$ugroupa = array();

//get all groups that the user is a member of

	       	$db = JFactory::getDbo();
	       	$db->setQuery(
		    'Select `id` FROM `#__usergroups`'.
		    ' where `title` LIKE "'. $level.'"'
		);
		$levelId = $db->loadResult();
		foreach ($groups as $groupId => $value){
			if($levelId == $groupId)
				return true;
		}
		return false;


	} // end hasAccessLevel
// ************************************************************************/
} // end class
?>